SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'JuanIgnacio 4/29/2013 19:26'!
blueGhost

	^Ghost new.! !

!PacManTest methodsFor: 'actors' stamp: 'JuanIgnacio 4/29/2013 19:46'!
blueberry

		^Blueberry new.! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 4/29/2013 20:50'!
down

	^(0@ -1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 4/29/2013 20:13'!
ghostHouseDoorType

	^GhostHouseDoor new.! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 4/29/2013 20:49'!
left

	^(-1@0).! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 4/29/2013 20:29'!
leftTransporterType

	^ Portal new.! !

!PacManTest methodsFor: 'actors' stamp: 'JuanIgnacio 4/29/2013 19:44'!
pacman
	^Pacman new.! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 4/29/2013 20:49'!
right

	^(1@0).! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 4/29/2013 19:48'!
spaceType
	^Space new.
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'JuanIgnacio 4/29/2013 20:07'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'JuanIgnacio 4/29/2013 21:58'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'JuanIgnacio 4/29/2013 20:49'!
up

	^(0@1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanIgnacio 4/29/2013 19:32'!
wallType

	^Wall new.! !

Object subclass: #Actor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Actor subclass: #Blueberry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Blueberry methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:22'!
moveIn: aGhostHouseDoor towards: aPoint 
	^aGhostHouseDoor  move: self InHouseDoorTowards: aPoint.! !

!Blueberry methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 19:47'!
position
	^0@0! !

!Blueberry methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:46'!
teletransport: aPortal to: aPoint 
	^ aPortal teleportFruit: self to: aPoint.! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:17'!
moveIn: aGhostHouseDoor towards: aPoint 
	^aGhostHouseDoor  move: self InHouseDoorTowards:aPoint.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 19:26'!
position
	^0@0! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:40'!
teletransport: aPortal to: aPoint 
	^ aPortal teleportGhost: self to: aPoint.! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:31'!
moveIn: aGhostHouseDoor towards: aPoint 
	^aGhostHouseDoor  movePacman: self InHouseDoorTowards: aPoint.! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 19:43'!
position
	^0@0.! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:47'!
teletransport: aPortal to: aPoint 
	^ aPortal teleportPacman: self to: aPoint.! !

Object subclass: #GhostHouseDoor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:29'!
move: anActor InHouseDoorTowards: aPoint 
	^ anActor position + aPoint.! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:32'!
movePacman: aPacman InHouseDoorTowards: aPoint 
	 ^aPacman position.! !

!GhostHouseDoor methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:55'!
nextPositionFor: anActor going: aDirection
	^ anActor moveIn: self towards: aDirection.
	
! !

Object subclass: #Portal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Portal methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 22:02'!
nextPositionFor: anActor going: aDirection 

	^anActor teletransport: self to: aDirection.
	
	"(anActor isKindOf: Blueberry) ifTrue: [ ^(5@10) ].
	(anActor isKindOf: Pacman) ifTrue: [ ^(3@10) ].
	(anActor isKindOf:  Ghost) ifTrue: [ ^ anActor position ]"! !

!Portal methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:48'!
teleportFruit: aBlueberry to: aPoint 
	^(5@10).! !

!Portal methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:41'!
teleportGhost: aGhost to: aPoint 
	^ aGhost position.! !

!Portal methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 21:48'!
teleportPacman: aPacman to: aPoint 
	^(3@10)! !

Object subclass: #Space
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Space methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 20:53'!
nextPositionFor: aGhost going: aDirection 
	 ^(aGhost position + aDirection) .
 	! !

Object subclass: #Wall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Wall methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 4/29/2013 20:59'!
nextPositionFor: aGhost going: aDirection 

 ^aGhost position  .
 ! !
